        PROGRAM mod_score                        
c	************************************************
C       ************************************************
C	Two point linkage analysis of quantitative traits
C	Pedigrees without loops
C	Elston-Stewart algorithm	
c	Maximization of all parameters is possible
c	Qtl - two alleles
c	Marker - up to 5 alleles    
C	************************************************
C	************************************************
C	pr(1)=frequency of qtl allele(p)
C	pr(2)-pr(4)=mu1,mu2,mu3 
C	pr(5)=teta
c	pr(6)=sigma
C	pr(7)=pr(m1)
C	pr(8)=pr(m2)
C	pr(9)=pr(m3)
C	pr(10)=pr(m4)
C	pr(11)=pr(m5)
C	************************************************
C	************************************************ 
	implicit double precision(a-h,o-z)
	EXTERNAL GENMMP
	include 'mas_size.inc'
c	************************************************
C	here the user common-blocks are coming
C	************************************************
	include 'usercom.inc'
	include 'methcom.inc'
	character*10 name_phen,name_mar,name_out 
 
	NPR=6
C	************************************************
C	READ: maximization parameters
C	************************************************
	open(unit=1,file='maxpar.inp')
	read(1,*)ip
	read(1,*)per
	read(1,*)ni
	read(1,*)red
	read(1,*)eps
ccc	read(1,*) npr
	close(1)
	
c	************************************************
C	READ: file names
C	************************************************
	open (unit=1,file='task.inp')
	read (1,*)name_phen
	read (1,*)name_mar
	read (1,*)name_out
	close (unit=1)
	IPOV=1

C	************************************************
        OPEN (UNIT=12,file='sigma.DAT')
        OPEN (UNIT=10,file=name_out)
C	************************************************
C	READ: initial parameters of model
C	************************************************
555	open (unit=1,file='par.inp')
c        READ (1,*)NS !!!,iskrin
c        READ (1,1111)(LUK(I),I=1,NS)
	read (1,*)
        DO  j=1,NPR
	    READ(1,*)inum(j),icp(j),PR(j),ST(j),GL(j),GR(j)
	end do
	do j=7,11
		read(1,*) pr(j)
	end do
        CLOSE (UNIT=1)
	if (IPOV.eq.1) then
	pr(5)=0.5
	icp(5)=0
	end if

	n_icp=0
	do i=1,npr
	n_icp=n_icp+icp(i)
	end do
C	************************************************
        call wwdat(name_phen,name_mar)
C	************************************************
	ndat=ins(ns+2)
777     IMAX=-1
	CALL GENMMP(F0)
	print 8887,f0
8887	format (' initial LH=',e15.8)
	H=F0
c	pause
	if (n_icp.eq.0) goto 666
        if (F0.le.-1.d17)stop
        IMAX=1
cc	open(unit=2,file='max.dat')

        CALL METHGI(NPR,EPS,RED,PER,NI,IP,GENMMP)
c        close(unit=2)
	if (ipov.eq.1)WRITE(12,1103)
	if (ipov.eq.2)WRITE(12,1104)
        WRITE (12,590)NITER,NFUN,H
        WRITE (12,596)
        DO J=1,NPR
        WRITE (12,592)J,PR(J),ST(J)
	end do
590     FORMAT (1X,' Number of iteration =',I4,
     *	/' Number of functions =',I6,/1X, ' ln LH =',E20.8)
596     FORMAT (10X,' Parameter',7X,'Step')
599	FORMAT ('  Number of observed individuals =',I4)
592     FORMAT (1X,I2,1X,2E15.6,3X,I2,1X,2E15.6)
1103	FORMAT ('**************************************',/,
     *	'NULL HYPOTHESIS: THETA=0.5',/,
     *	'**************************************') 
1104	FORMAT ('**************************************',/,
     *	'ALTERNATIVE HYPOTHESIS: THETA<0.5',/,
     *	'**************************************') 
666     if (IPOV.eq.1)then
	Write (10,1010)H
	h1=h
1010	Format ('LH(0.5)=',E14.7)
	else
	f_lh=2.*(h-h1)
	f_LOD=f_lh/4.6
	Write (10,1011)Pr(5),H
	Write (10,1012)f_lh
	Write (10,1013)f_LOD
	end if
1012	Format ('-2ln(L1/L2)=',E14.7)
1011	Format ('LH(',f5.3,')=',E14.7)
1013	Format ('LOD SCORE=',E14.7)

	if (IPOV.eq.2)goto 888
	IPOV=2
	goto 555
888     close(unit=12)
	close(unit=10)
1111	format(20i1)
        END
C	************************************************
      SUBROUTINE GENMMP(FLH)
C	************************************************
C	LH for pedigree sample 
C	************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  	include 'mas_size.inc'
	include 'usercom.inc'
	include 'methcom.inc'
C	************************************************
	if (imax.eq.-1)then
	call stap0(ch)
	goto 9999
	else
	call stapar(ch)
	end if
9999	if(ch+1.e18)92,92,99
9992	if (max.eq.-1)then
	write(25,9993)is
	print 9993,is
	pause
	end if
9993	format (' PROBABILITY OF FAMILY',i4,'=0')
92	FLH=-1.e18
	return
99	FLH=0.
	NS=INS(1)
	DO 1 IS=1,NS
c	print *,'GENMMP',is
c	pause
	FL=0.
	FSS=0.
	IPOVT=0 ! numenator
100	LS0=INS(IS+1)
	LS1=LS0+1
	LS2=INS(IS+2)
	LSS=ls2-ls0
	Lp1=ips(is+1)+1
	Lp2=ips(is+2)
	lps=lp2-lp1+1
	CALL MASSIX(IS)

c	IF(LPS.GT.0)GOTO 20
c	S=0.
c	DO 11 IG=1,55
c	DO 11 ig_p=1,7
c11	S=S+XX(1,IG)
c	FS=DLOG(S)
c	if (s.eq.one)FS=0.D+00
c	GOTO 2

20	CALL MMPFAM(IS,FS)

2	IF (IPOVT.ne.0)GOTO 30
	FL=FL+FS
	if (iskrin.eq.0)goto 1001
	IPOVT=1
	GOTO 100
30	ffl=FL
	FL=FL-FS
1001	FLH=FLH+FL
1	CONTINUE
	RETURN
	END
c	**************************************
        SUBROUTINE WWDAT(name_phen,name_mar)
	implicit double precision (a-h,o-z)
c	***************************************
	include 'mas_size.inc'
	include 'usercom.inc'
	character*10 name_phen,name_mar
        OPEN (UNIT=2,file='IWAY.DAT')
        READ (2,*)NS,(INS(J),J=1,NS+2)
	if (NS.gt.N_FAM+2)stop'N_FAM exceed. Correct and recompile'
        READ (2,*)(IPS(J),J=1,NS+2)
        READ (2,*)LSS,(INP(J),J=1,LSS)
	if (LSS.gt.N_WAY)stop'N_WAY exceed. Correct and recompile'
        read (2,*)LS,(INF(J),J=1,LS)
	if (LS.gt.N_WAY)stop'N_WAY exceed. Correct and recompile'
        read (2,*)(IWAY(j),j=1,LSS-2)
        read (2,*)nd,(jsex(i),i=1,nd)
	if (ND.gt.N_SIZE)stop'N_SIZE exceed. Correct and recompile'
        read (2,*)(iprob(i),i=1,nd)
2       close (unit=2)
 
        OPEN (UNIT=2,file=name_phen)
	read (2,*)(dat(i),i=1,nd)
c	dat(i)=-999.D+00
	close (unit=2)

        OPEN (UNIT=2,file=name_mar)
	read (2,*)(mark(i),i=1,nd)
c	mark(i)=0
	close (unit=2)
	
        RETURN
        END
c	*********************************************************
c	*********************************************************
        SUBROUTINE STAP0(CH)
	implicit double precision (a-h,o-z)
c	*********************************************************
	include 'mas_size.inc'
	include 'usercom.inc'
	include 'methcom.inc'
	dimension hh(10),k_gen(10)
	dimension n_gen(25)
	data k_gen /0,10,19,27,34,40,45,49,52,54/
	data n_gen/1,2,3,4,5,2,6,7,8,9,3,7,10,11,12,4,8,
     *	11,13,14,5,9,12,14,15/
	CH=one
	do 55 J=1,npr
	nnn=inum(j)
	if(nnn.eq.j)goto 55
	icp(j)=0
	pr(j)=pr(nnn)
55	continue
        DO 90 J=1,NPR
        if (icp(j).eq.0)goto 90
        IF (PR(J).Le.GL(J))GOTO 92
        IF (GR(J).Le.PR(J))GOTO 92
90      CONTINUE
c	Testing of allele frequencies
	s=0.
	do j=7,11
	s=s+pr(j)
	end do
	if (abs(s-one).gt.1.e-05)then
	print *,'ERROR: sum of marker allele frequencies is not 1'
        print *,'Check of PAR.INP'
	pause
	stop
	end if

c	frequencies of haplotypes
        P=PR(1)
	n=0
	do i=1,2
	q=p
	if (i.eq.2)q=one-p
	do j=1,5
	n=n+1
	hh(n)=q*pr(j+6)
	end do
	end do

c	frequencies of genotypes
	do i=1,55
	PP(i)=0.
	end do
 
	do i1=1,10
	j1=1
	m1=i1
	if (i1.ge.6)then
	j1=2
	m1=i1-5
	end if
	do i2=1,10
	kk=k_gen(i1)+i2-i1+1
	if (i2.lt.i1)kk=k_gen(i2)+i1-i2+1
	PP(kk)=PP(kk)+hh(i1)*hh(i2)
	j2=1
	m2=i2
	if (i2.ge.6)then
	j2=2
	m2=i2-5
	end if
	k_qtl(kk)=j1+j2-1
	k_mar(kk)=n_gen((m1-1)*5+m2)
	end do
	end do

	ppp=0
	do i=1,55
	ppp=ppp+pp(i)
	end do
	if (ppp-one.gt.1.d-07)then
	print *,'Sum_p.ne.1',ppp
	pause
	end if
 
	do i=1,55
	do j=1,10
	be(i,j)=0.D+00
	end do
	end do

	teta=pr(5)

	do i=1,10
	kk=k_gen(i)+1
	be(kk,i)=one
	end do
  
	do i1=1,9
	do i2=i1+1,10
	kk=k_gen(i1)+i2-i1+1
	be(kk,i1)=0.5D+00
	be(kk,i2)=0.5D+00
	end do 
	end do

	do i1=1,5
	do i2=6,10
	if (i2.eq.i1+5)goto 333
	kk=k_gen(i1)+i2-i1+1
	be(kk,i1)=0.5*(one-teta)
	be(kk,i2)=0.5*(one-teta)
	be(kk,i1+5)=0.5*teta
	be(kk,i2-5)=0.5*teta
333	END DO
	end do

	do i=1,166375
	bbb(i)=0.D+00
	end do

	do i=1,55
	do j=1,55
	ppp=0.D+00
	do k1=1,10
	b1=be(i,k1)
	do k2=1,10
	kk=k_gen(k1)+k2-k1+1
	if (k2.lt.k1)kk=k_gen(k2)+k1-k2+1
	bbb(3025*(i-1)+55*(j-1)+kk)=bbb(3025*(i-1)+55*(j-1)+kk)+b1*be(j,k2)
	ppp=ppp+b1*be(j,k2)
	end do
	end do
	if (ppp-one.gt.1.d-10)then
	print *,'Sum_bbb.ne.1',i,j
	pause
	end if
	end do
	end do

	smu(1)=pr(2)
	smu(2)=pr(3)
	smu(3)=pr(4)
c	pga=pr(5)
	sigma=sqrt(pr(6))
	call GENOTYPE      
	goto 200
92      CH=-1.d18

200	RETURN
        END
c	***********************************************************
c	*********************************************************
        SUBROUTINE STAPAR(CH)
	implicit double precision (a-h,o-z)
c	*********************************************************
	include 'mas_size.inc'
	include 'usercom.inc'
	include 'methcom.inc'
	dimension hh(10),k_gen(10)
	data k_gen /0,10,19,27,34,40,45,49,52,54/
	CH=one
	do 55 J=1,npr
	nnn=inum(j)
	if(nnn.eq.j)goto 55
	icp(j)=0
	pr(j)=pr(nnn)
55	continue
        DO 90 J=1,NPR
        if (icp(j).eq.0)goto 90
        IF (PR(J).Le.GL(J))GOTO 92
        IF (GR(J).Le.PR(J))GOTO 92
90      CONTINUE

c	frequencies of haplotypes
        P=PR(1)
	n=0
	do i=1,2
	q=p
	if (i.eq.2)q=one-p
	do j=1,5
	n=n+1
	hh(n)=q*pr(j+6)
c	print *,i,j,pr(j+6)
c	pause
	end do
	end do

c	frequencies of genotypes
	do i=1,55
	PP(i)=0.D+00
	end do

	do i1=1,10
	do i2=1,10
	kk=k_gen(i1)+i2-i1+1
	if (i2.lt.i1)kk=k_gen(i2)+i1-i2+1
	PP(kk)=PP(kk)+hh(i1)*hh(i2)
	end do
	end do

	ppp=0
	do i=1,55
	ppp=ppp+pp(i)
	end do
	if (ppp-one.gt.1.d-05)then
	print *,'Sum_p.ne.1',ppp
	pause
	end if
 
	do i=1,55
	do j=1,10
	be(i,j)=0.D+00
	end do
	end do

	teta=pr(5)

	do i=1,10
	kk=k_gen(i)+1
	be(kk,i)=one
	end do
  
	do i1=1,9
	do i2=i1+1,10
	kk=k_gen(i1)+i2-i1+1
	be(kk,i1)=0.5D+00
	be(kk,i2)=0.5D+00
	end do 
	end do

	do i1=1,5
	do i2=6,10
	if (i2.eq.i1+5)goto 333
	kk=k_gen(i1)+i2-i1+1
	be(kk,i1)=0.5*(one-teta)
	be(kk,i2)=0.5*(one-teta)
	be(kk,i1+5)=0.5*teta
	be(kk,i2-5)=0.5*teta
333	END DO
	end do

	do i=1,166375
	bbb(i)=0.D+00
	end do

	do i=1,55
	do j=1,55
	ppp=0.D+00
	do k1=1,10
	b1=be(i,k1)
	do k2=1,10
	kk=k_gen(k1)+k2-k1+1
	if (k2.lt.k1)kk=k_gen(k2)+k1-k2+1
	bbb(3025*(i-1)+55*(j-1)+kk)=bbb(3025*(i-1)+55*(j-1)+kk)+b1*be(j,k2)
	ppp=ppp+b1*be(j,k2)
	end do
	end do
	if (ppp-one.gt.1.d-10)then
	print *,'Sum_bbb.ne.1',i,j
	pause
	end if
	end do
	end do

	smu(1)=pr(2)
	smu(2)=pr(3)
	smu(3)=pr(4)
	pga=pr(5)
	sigma=sqrt(pr(6))

	goto 200
92      CH=-1.d18
200     RETURN
        END
c	***********************************************************

c	
	FUNCTION FEN(M,IG)
C	********************************
C	M - number of person, IG - his/her genotype
C	********************************
	implicit double precision (a-h,o-z)
	include 'mas_size.inc'
	include 'usercom.inc'
	F=one
	ddd=dat(m)
	mmm=mark(m)
	if (ddd.le.-998.and.mmm.eq.0)goto 555
ccc	if (iskrin.eq.0)goto 7
ccc	if (ipovt.ne.0.and.iprob(m).eq.2)goto 555	!!!!!!!!!!!!!!
7	ig_qtl=k_qtl(ig)
	ig_mar=k_mar(ig)              
	if (mmm.eq.0) goto 223
	if (mmm.ne.ig_mar) goto 222
223	if (ddd.le.-998)goto 555
	xxx=smu(ig_qtl)
       	y=(xxx-ddd)/sigma
	z1=exp(-0.5*y*y)
	f=z1/sigma

	goto 555
222	f=0.D+00
555	fen=f
	return
	end
C*******************************************************      
      SUBROUTINE MASSIX(IS)
C***************************************
C    WRITING OF MASSIV XX
C***************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	include 'mas_size.inc'
	include 'usercom.inc'
      DIMENSION IYK(N_SIZE)
C**********************************************************************
	LSO=INS(IS+1)      !NUMBER OF PERSONS UP TO FAMILY IS
	LS2=INS(IS+2)
       LSS=LS2-LSO  !NUMBER OF MEMBERS IN FAMILY IS
	LG0=IGS(LSO+2)
	LGS=IGS(LS2+2)-LG0

C*****Start of massives XX and IYK***************************
       DO I=1,LSS
        IYK(I)=0
	end do
        DO IG=1,LGS
        XX(IG)=one
	end do
C*********************************************************
       LP0=IPS(IS+1) !NUMBER OF NUCL.FAMILIES UP TO IS      
       LP1=LP0+1 !NUMBER OF FIRST NUCLEAR FAMILY
       LP2=IPS(IS+2) ! NUMPER OF LAST NUCLEAR FAMILY
       LPS=IPS(IS+2)-LP0 !NUMBER OF NUCL.FAMILIES IN FAMILY IS
	IF (LPS.LE.0)GOTO 888
C ******WRITING OF XX FOR OFFSPRINGS*****************************
        DO 24 IQ=LP1,LP2 
         LN0=INP(IQ+1) !NUMBER OF PERSONS UP TO NUCL.FAMILY IQ
         LNS=INP(IQ+2)-LN0 !NUMBER OF PERSONS IN NUCL.FAMILY IQ
         IF(LNS.LE.2)GOTO 24
	nfat=LN0+1		!ADDRESS OF FATHER
	nmat=LN0+2		!ADDRESS OF MOTHER
         NNF1=LN0+3              !ADDRESS OF THE FIRST OFFSPRING
         NNF2=LN0+LNS            !ADDRESS OF THE LAST OFFSPRING
          DO 3 IO=NNF1,NNF2      
           NOFF=INF(IO)          !NUMBER OF OFFSPRING WITH ADDRES IO 
           IO1=NOFF+LSO          !COMMON NUMBER OF THIS OFFSPRING
           D=DAT(IO1)          !TRAIT OF THIS OFFSPRING
           IYK(NOFF)=1            !INDICATOR OF XX WRITING
           IF(D.LE.-1.d+07)GOTO 3
            DO 2 IIG=1,i0_gen(IO1)
            IG=i_gen(IGS(IO1+1)+IIG)
             XX(IGS(IO1+1)+IIG-LG0)=FEN(IO1,IG)
2           CONTINUE
3         CONTINUE
24     CONTINUE
C*********WRITING OF XX FOR PARENTS*************
        DO 74 IQ=LP1,LP2           
         LN0=INP(IQ+1)   !NUMBER OF PERSONS UP TO NUCL.FAMILY IQ
         LNS=INP(IQ+2)-LN0  !NUMBER OF PERSONS IN NUCL.FAMILY IQ
	ii=2
	if(lns.eq.1)ii=1
	DO 75 IPAR=1,ii
         NPAR=INF(LN0+IPAR)   !NUMBER OF PARENT
         NFI=NPAR+LSO      !COMMON NUMBER OF PARENT 
         D=DAT(NFI)             !TRAIT OF PARENT
         IF(IYK(NPAR).EQ.1)GOTO 75
         IYK(NPAR)=1
         IF(D.gT.-1.d+07)GOTO 32     
          DO 31 IIG=1,i0_gen(NFI)
          IG=i_gen(IGS(NFI+1)+IIG)      !UNTREATED PARENT

31        XX(IGS(NFI+1)+IIG-LG0)=PP(IG) !FROM POPULATION
	GOTO 75
32         DO 5 IIG=1,i0_gen(NFI)
          IG=i_gen(IGS(NFI+1)+IIG) 
          XX(IGS(NFI+1)+IIG-LG0)=FEN(NFI,IG)*PP(IG)
5         CONTINUE
75	CONTINUE
74	CONTINUE
888	DO 101 IO=1,LSS
	IF(IYK(IO).EQ.1)GOTO 101
	NFI=LSO+IO
	D=DAT(NFI)
	IF (D.gt.-1.d+07)GOTO 102
        DO 76 IIG=1,i0_gen(NFI)
        IG=i_gen(IGS(NFI+1)+IIG)
76	XX(IGS(NFI+1)+IIG-LG0)=PP(IG)
	GOTO 101
102     DO 77 IIG=1,i0_gen(NFI)
        IG=i_gen(IGS(NFI+1)+IIG)
77	XX(IGS(NFI+1)+IIG-LG0)=PP(IG)*FEN(NFI,IG)
101	CONTINUE 

      RETURN
      END

      SUBROUTINE MMPFAM(IS,FS)
C	********************************
C	PEDIGREE CONVOLUTION
C	FS is LOG(LH)
C	********************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	include 'mas_size.inc'
	include 'usercom.inc'
C***************************************************
	LS0=INS(IS+1)
	LSS=INS(IS+2)-LS0 !number of pedigree members
      LP0=IPS(IS+1)   
      LP2=IPS(IS+2)   
      LPS=LP2-LP0 !  number of nucl.families in pedigree IS     
	LG0=IGS(LS0+2)
      FS=0. ! Lukelihood
	PRES=0. ! Parameter of preservation
      IQ=LP0+1   !number of nuclear family
1     NOSB=IWAY(IQ)!number of pointer
      LN0=INP(IQ+1)!start of massive INF
      LN2=INP(IQ+2)
      LNS=LN2-LN0  !size of nuclear family
      NFAT=INF(LN0+1)
      NMAT=INF(LN0+2)
c	print *,iq,nosb,nfat,nmat
c	pause
      IFF=1
      IF(NOSB.NE.0)GOTO 12
      NOSB=NFAT
      IFF=0
12    IF(NOSB.NE.NFAT.AND.NOSB.NE.NMAT)GOTO 19
C*****  CONVOLUTION ON ONE OF PARENTS **************      
      KN1=NFAT
      KN2=NMAT
      IF(NOSB.EQ.NFAT)GOTO 13
      KN1=NMAT
      KN2=NFAT
13    DO 14 IIG1=1,i0_gen(KN1+LS0)
      IG1=i_gen(IGS(KN1+LS0+1)+IIG1)
c	print *,KN1+LS0,ig1,xx(IGS(kn1+1+LS0)+iig1-LG0)
c	pause
      S=0.D+00
      DO 15 IIG2=1,i0_gen(KN2+LS0)
      IG2=i_gen(IGS(KN2+LS0+1)+IIG2)
c	print *,KN2+LS0,i0_gen(KN2+LS0)
c	pause

      X2=XX(IGS(KN2+1+LS0)+IIG2-LG0)
      FS1=one
      IF(LNS.EQ.2)GOTO 27
      DO 16 IO=3,LNS
      IO1=INF(LN0+IO)
      SS=0.D+00
      DO 17 IIG=1,i0_gen(IO1+LS0)
      IG=i_gen(IGS(IO1+LS0+1)+IIG)
c	print *,IO1+LS0,i0_gen(IO1+LS0)
c	pause
                                      
17    SS=SS+BBB(3025*(ig1-1)+55*(ig2-1)+ig)*XX(IGS(IO1+1+LS0)+IIG-LG0)
      FS1=FS1*SS
16    CONTINUE
27    S=S+X2*FS1
15    CONTINUE
      XX(IGS(KN1+1+LS0)+IIG1-LG0)=S*XX(IGS(KN1+1+LS0)+IIG1-LG0)
14	continue
      GOTO 66
C*******CONVOLUTION ON ONE OF OFFSPRINGS************
19	IF(LNS.GT.3)GOTO 30
      IO=INF(LN0+3)
c	print *,'io=',io,i0_gen(io+ls0)
      DO 45 IIG0=1,i0_gen(IO+LS0)
      IG0=i_gen(IGS(IO+LS0+1)+IIG0)
c	print *,IO,IG0
      SS=0.D+00
      DO 46 IIG1=1,i0_gen(NFAT+LS0)
      IG1=i_gen(IGS(NFAT+LS0+1)+IIG1)
      X1=XX(IGS(NFAT+1+LS0)+IIG1-LG0)
c	print *,NFAT,IG1,X1
      DO 46 IIG2=1,i0_gen(NMAT+LS0)
      IG2=i_gen(IGS(NMAT+LS0+1)+IIG2)
      SS=SS+X1*XX(IGS(NMAT+1+LS0)+IIG2-LG0)*
     *	BBB(3025*(ig1-1)+55*(ig2-1)+ig0)
c	print *,NMAT,IG2,XX(IGS(NMAT+1+LS0)+IIG2-LG0)
c	pause
46    CONTINUE
      XX(IGS(IO+1+LS0)+IIG0-LG0)=SS*XX(IGS(IO+1+LS0)+IIG0-LG0)
45    CONTINUE
	GOTO 66            
30    DO 31 IIG0=1,i0_gen(NOSB+LS0)
      IG0=i_gen(IGS(NOSB+LS0+1)+IIG0)
      SS=0.D+00
      DO 32 IIG1=1,i0_gen(NFAT+LS0)
      IG1=i_gen(IGS(NFAT+LS0+1)+IIG1)
      X1=XX(IGS(NFAT+1+LS0)+IIG1-LG0)
      DO 32 IIG2=1,i0_gen(NMAT+LS0)
      IG2=i_gen(IGS(NMAT+LS0+1)+IIG2)
      X2=XX(IGS(NMAT+1+LS0)+IIG2-LG0)
      FS1=one
      DO 33 IO=4,LNS
	IO1=INF(LN0+IO)
      S=0.D+00
      DO 34 IIG=1,i0_gen(IO1+LS0)
      IG=i_gen(IGS(IO1+LS0+1)+IIG)
34    S=S+BBB(3025*(ig1-1)+55*(ig2-1)+ig)*XX(IGS(IO1+1+LS0)+IIG-LG0)
      FS1=FS1*S
33    CONTINUE      
      FS1=FS1*BBB(3025*(ig1-1)+55*(ig2-1)+ig0)
      SS=SS+FS1*X1*X2
32    CONTINUE
      XX(IGS(NOSB+1+LS0)+IIG0-LG0)=SS*XX(IGS(NOSB+1+LS0)+IIG0-LG0)
31	continue
cc	pause
66    	s=0.D+00
        DO 20 IIG=1,i0_gen(nosb+LS0)
        IG=i_gen(IGS(nosb+LS0+1)+IIG)
20	s=s+xx(IGS(nosb+1+LS0)+iig-LG0)
777	dds=dlog(s)
	if (s.eq.one)dds=0.D+00
	pres=pres+dds
c	print *,'MMPFAM',nosb,dds,pres
c	pause
	ss=one/s
	s=0.D+00
        DO 21 IIG=1,i0_gen(nosb+LS0)
        IG=i_gen(IGS(nosb+LS0+1)+IIG)
	xx(IGS(nosb+1+LS0)+iig-LG0)=xx(IGS(nosb+1+LS0)+iig-LG0)*ss
21	s=s+xx(IGS(nosb+1+LS0)+iig-LG0)
	IF(IFF.NE.0)GOTO 68
	dds=dlog(s)
	if (s.eq.one)dds=0.D+00
      FS=FS+dds
68    continue
      IQ=IQ+1
      IF(IQ.LE.LP2)GOTO 1
	fs=fs+pres
      RETURN
      END
        SUBROUTINE METHGI(N,EP,R,PER,NC,IP,FUN)
C       ******************************************
C       Maximization of LH (FUN)
C       ******************************************
	implicit double precision (a-h,o-z)
        EXTERNAL FUN
	include 'mas_size.inc'
	include 'methcom.inc'
        DIMENSION Y(MAXPAR)
	eps=1.d-17
        IF (N)70,70,6 
6       IF (N-MAXPAR)1,1,65
1       KK=0
        NITER=0
        NFUN=1
        BEGIN=-1.d18
        N1=0
        DO 2 J=1,N
        N1=N1+ICP(J)
2       Y(J)=Pr(J) 
        CALL FUN(F1)

        IF (F1.le.-1.d17)goto 70
101     DO 103 J=1,N
        IF (ICP(J).EQ.0)GOTO 103
        IF (KK.EQ.1)St(J)=St(J)*0.5 
        K=2 
        Pr(J)=Pr(J)-St(J)
102     CALL FUN(F) 

        IF (F.LE.-1.d17)GOTO 107 
107     NFUN=NFUN+1 
        IF (F1.lt.F)goto 23 
        K=K+1 
        Pr(J)=Pr(J)+2.*St(J) 
        IF (K-3)103,31,103
31      St(J)=-St(J)*.5 
        GO TO 102 
23      St(J)=St(J)*1.5 
        F1=F
103     CONTINUE
        DO 24 J=1,N 
        IF (ICP(J).EQ.0)GOTO 24 
        X=2.*Pr(J)-Y(J)
        Z=Pr(J)-Y(J) 
        IF (Z)201,203,202 
201     IF (GL(J)-X)203,211,211 
211     X=GL(J)+eps
        GOTO 203
202     IF (GR(J)-X)212,212,203 
212     X=GR(J)-eps
203     CONTINUE
        Y(J)=Pr(J) 
        Pr(J)=X
24      CONTINUE
        K=5 
104     CALL FUN(F) 
        NFUN=NFUN+1 
        IF (F-F1)25,25,50 
25      K=K+1 
        DO 26 J=1,N 
        IF (ICP(J).EQ.0)GOTO 26 
        Pr(J)=Y(J)*(one-R)+Pr(J)*R 
26      CONTINUE
        IF (K-15)104,27,27
27      KK=1
        CALL FUN(F) 
        NFUN=NFUN+1 
        GO TO 53
50      KK=0
        IF (F-BEGIN-EP)521,53,53
521     CONTINUE
	h=f
	if(f.gt.-1.d18)goto 599
	h=f1
	do 600 i=1,n
600     pr(i)=y(i)
599     NITER=NITER+1 
        GO TO 512 
53      KP=0
        DO 54 J=1,N 
        IF (ICP(J).EQ.0)GOTO 54 
        IF (ABS(PER*Pr(J))-ABS(St(J)))45,531,531
45      IF (ABS(St(J))-1.d-06)531,54,54
531     KP=KP+1 
54      CONTINUE
        IF (KP-N1)52,521,521
52      NITER=NITER+1 
        IF (NITER-NC)51,51,511 
511     CONTINUE
        WRITE (25,594) 
594     FORMAT (1X,'MAXIMUM NOT FOUND')
512        RETURN
51	IF (IP-1)55,501,501
501	ff=f1
	if(f.gt.ff)ff=f
c	WRITE (2,590)NITER,NFUN,FF,f,f1
	print 590,NITER,NFUN,FF
c        WRITE (2,596)
        DO 555  J=1,N
	jj=j+10
c        WRITE (2,592)J,Pr(J),St(J),jj,pr(jj),st(jj)
555     CONTINUE
590     FORMAT (1X,'number of iterations =',I4,
     *	/' number of functions =',I6,
     *  /1X, 'ln LH =',3E20.8)
596     FORMAT (8X,'parameter',7X,'step',15X,'parameter',7X,'step')
592     FORMAT (1X,I2,1X,2E15.6,3X,I2,1X,2E15.6)
593     FORMAT (1X,/) 
55      IF (F+1.d17)551,551,550 
550     F1=F
551     BEGIN=F1
        GO TO 101 
65	write(25,595)
595	Format (' Number of estimated param.>30')
70      RETURN
        END 


      SUBROUTINE GENOTYPE
C	*************************************
C	elimination of genotypes 
C	*************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  	include 'mas_size.inc'
	include 'usercom.inc'
	dimension iflag(55,N_SIZE)
c	**************************************
	NS=INS(1)
	NDAT=INS(NS+2)
	do i=1,55
	do j=1,NDAT
	iflag(i,j)=1
	end do
	end do

C	Testing of personal marker genotype

	N0=0
	do i=1,ndat
	mmm=mark(i)
	if (mmm.eq.0)then
	n0=n0+55
	goto 11
	end if
	do ig=1,55
	if (k_mar(ig).ne.mmm)then
	iflag(ig,i)=0
	goto 111
	end if
	N0=N0+1
111	end do
11	end do
	Print *,'N0=',n0

c	Testing of compatibility with offspring genotypes

200	do is=1,ns
	ls0=ins(is+1)
	lp0=ips(is+1)
	lp1=lp0+1
	lp2=ips(is+2)

	do IQ=lp1,lp2
	LNO=inp(IQ+1)
	LNS=inp(IQ+2)-LNO
	nf=INF(LNO+1)+LS0
	nm=INF(LNO+2)+LS0
	ioff=LNS-2

	do igf=1,55
	if (iflag(igf,nf).eq.0)goto 12
	s=0.D+00

	do igm=1,55
	if (iflag(igm,nm).eq.0)goto 13
	do j=1,ioff
	io=INF(LNO+2+j)+LS0
	do ig=1,55
	if (iflag(ig,io).eq.0)goto 15
	s=s+bbb(3025*(igf-1)+55*(igm-1)+ig)	
15	end do
	end do
13	end do
        if (s.lt.1.d-15)iflag(igf,nf)=0
12	end do

	do igm=1,55
	if (iflag(igm,nm).eq.0)goto 112
	s=0.D+00

	do igf=1,55
	if (iflag(igf,nf).eq.0)goto 113
	do j=1,ioff
	io=INF(LNO+2+j)+LS0
	do ig=1,55
	if (iflag(ig,io).eq.0)goto 115
	s=s+bbb(3025*(igf-1)+55*(igm-1)+ig)	
115	end do
	end do
113	end do
        if (s.lt.1.d-15) iflag(igm,nm)=0
112	end do
	end do

	n1=0
	do i=1,ndat
	do ig=1,55
	if (iflag(ig,i).eq.1)n1=n1+1
	end do
	end do
	end do
	print *,'N1=', n1
	if (n0.gt.n1)then
	n0=n1
	goto 200
	end if
	if (N1.gt.N_WAY) then
	print *,'Number of possible genotypes > N_WAY'
	pause
	stop
	end if

	IGS(1)=NDAT
	IGS(2)=0
              
	n=0
	do i=1,NDAT
	do ig=1,55
	if (iflag(ig,i).eq.0)goto 10
	n=n+1
	i_gen(n)=ig
10	end do
	IGS(i+2)=n
	end do

	do i=1,ndat
	i0_gen(i)=IGS(i+2)-IGS(i+1)
c	print 100,i,mark(i),i0_gen(i)
c	pause
	end do

100	format (20i4)
	return
	end
